import { Component, OnInit } from '@angular/core';
import { NgbModal } from '@ng-bootstrap/ng-bootstrap';
import { BackendService, Task } from '../services/backend.service';
import { TaskFormComponent } from '../task-form/task-form.component';

@Component({
  selector: 'app-task-list',
  templateUrl: './task-list.component.html',
  styleUrls: ['./task-list.component.css']
})
export class TaskListComponent implements OnInit {

  public tasks: Task[] = [];

  constructor(private backendService: BackendService, private modalService: NgbModal) { 
      backendService.getTasks().subscribe(response => {
          if (response.status > 399) {
              alert('Fehler');
          }
          else {
              this.tasks.push(...response.body);
          }
      });
  }

  ngOnInit(): void {
  }

  public deleteTask(task: Task) {
    this.backendService.deleteTask(task).subscribe(response => {
      if (response.status > 399) {
        alert('Fehler');
      }
    });
    const index = this.tasks.indexOf(task);
    if (index !== -1) {
      this.tasks.splice(index, 1);
    }    
  }

  public openTaskForm(editTask: Task) {
    const modalRef = this.modalService.open(TaskFormComponent, {
      backdrop: 'static',
      keyboard: true,
    });
    modalRef.componentInstance.task = editTask;
  }

}
